unit untTest;

{ Use This program to detremine the maximum time resolution of your computer }
{ I tested the program on a AMD-K6 I-200 MHz with 128MB RAM', and got a }
{ average resolution of 0.00013 seconds, equal to a frequency of 7700 Hz }
{ The faster your processor is, the better is your time resolution }


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  HighPrecisionTimer, StdCtrls;

type
  TForm1 = class(TForm)
    hp: THPTimer;
    cmdGo: TButton;
    lst: TListBox;
    lst2: TListBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    txtFreq: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    lblTP: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    lblMHz: TLabel;
    procedure cmdGoClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure txtFreqChange(Sender: TObject);
    procedure hpHighPrecisionTimer(seconds, Delta: Extended; N: Int64);
  private
    { Private-Deklarationen}
    FN : int64 ;
    SL : TStringList ;
    S : array of double ;
    dt : array of double ;
    n : integer ;
  public
    { Public-Deklarationen}
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.cmdGoClick(Sender: TObject);
var
 i : integer ;
 avg, min : double ;
begin
     if not(hp.enabled) then begin
        lst.items.clear ;
        lst2.items.clear ;
        SL.clear ;
        cmdGo.caption := 'Stop' ;
        SetLength (s,0) ;
        SetLength (dt,0) ;
        fn := 0 ;
     end else begin
        for i := 0 to fn-1 do lst.items.add (FormatFloat('0.0000000',S[i])) ;
        //lst.items.assign (SL) ;
        for i := 0 to fn-1 do begin
           lst2.items.Add (FormatFloat('0.0000000',dt[i])) ;
        end ;
        min := dt[0] ;
        avg := dt[0] ;
        for i := 1 to fn-1 do begin
          if dt[i] < min then min := dt[i] ;
          avg := avg + dt[i] ;
        end ;
        avg := avg / fn  ;
        label1.caption := 'min = ' + FormatFloat ('0.0000000',min) + ' sec.' ;
        label2.caption := 'avg = ' + FormatFloat ('0.0000000',avg) + ' sec.' ;
        cmdGo.caption := 'Start' ;
     end ;
     hp.enabled := not(hp.enabled) ;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
     SL := TStringList.create ;
     txtFreq.text := formatfloat ('0',HP.Frequency) ;
     lblMHz.caption := FormatFloat ('0.00',HP.ProcessorSpeed) + ' MHz' ;
end;

procedure TForm1.txtFreqChange(Sender: TObject);
begin
     hp.Frequency := StrToFloat (txtFreq.text) ;
     lblTP.caption := FormatFloat ('0.000000',hp.TimePeriod) + 'sec.' ;
end;

procedure TForm1.hpHighPrecisionTimer(seconds, Delta: Extended; N: Int64);
begin
     SetLength  (S,n) ;
     SetLength  (dt,n) ;
     S[n-1] := Seconds ;
     dt[n-1] := Delta ;
     FN := n ;
end;

end.
